/*
BURLACU BOGDAN
GRUPA 1406
TEMA NR 1
Se da un numar natural de maxim 4 cifre, n. Afisati cate numere mai mari decat n se pot forma respectand urmatoarea conditie: sunt folosite toate cifrele lui n, cu exact acelasi numar de aparitii ca în cazul lui n
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

unsigned int r = 0; //rezultat

//functia fact: calculeaza n factorial
unsigned int fact(int n) {

	unsigned int p = 1, i;
	for (i = 1; i <= n; i++)
		p *= i;

	return p;

}

//functia count: numara cifrele care se repeta si salveaza nr de repetari ale fiecarei cifre intr-un vector
unsigned int * count(char *s, unsigned int p) {

	char *aux = malloc(strlen(s)*sizeof(char));//aux = string auxiliar, ajuta la numaratoare
	unsigned int i, j, c, k;//i,j = indecsi; c = counter pt nr de repetari, k = pozitia in v
	unsigned int *v = malloc(strlen(s)*sizeof(int));//v = vectorul in care se salveaza nr de repetari ale fiecarei cifre; nr de elem != 0 ale lui v reprezinta numarul cifrelor care se repeta

	for (i = 0; i < strlen(s); i++){
		aux[i] = s[i];
		v[i] = 0;
  }

	//initializari
	c = 0;
	k = 0;

	for (i = p; i < strlen(s); i++){
		for (j = p; j < strlen(s); j++)
			if ((aux[i] == aux[j]) && (aux[j] != 'x') && (i != j)){
				if (c == 0) c += 2;
					else c++;
				aux[j] = 'x';
			}

	//acest while serveste la stabilirea pozitiei k pe care sa fie salvat nr de repetari ale cifrei, in vectorul v
		while (v[k]!=0)
	  	k++;

		v[k] = c;
		c = 0;
	}

	free(aux);

	return v;

}
			
//functia nr: aplica formula de calcul pentru rezolvarea problemei
void nr(char *s, unsigned int p) {

	unsigned int x, i;
	unsigned int *v;
	unsigned int cifre;
	unsigned int num, den;

	//initializari
	x = 0;
	num = 0;
	den = 1;
	v = count(s,p);
	cifre = strlen(s) - p;

	//aflu nr cifrelor mai mari decat prima cifra
	for (i = p; i < strlen(s); i++)
		if (s[p] < s[i])
			x++;

	//numitorul este produsul factorialelor numerelor de repetari ale cifrelor care se repeta 
	while (v[num] != 0){
		den *= fact(v[num]);
		num++;
	}
	
	r += x * fact(cifre-1) / den;

}

int main(void) {

	unsigned int i = 0;
	char *s;
	char c = '0';

	s = malloc(5*sizeof(char));

	printf("Introduceti numarul: ");
	
	while ((c != '\n') && (i < 4)){
	  c = getchar();
		if ((c >= '0') && (c <= '9')) {
			s[i]=c;
			i++;
		}
	}

	s[i] = '\0';

	if (strlen(s) == 0){
		printf("\nEroare: date incorecte\n\n");
		exit(-1);
	}

	for (i = 0; i < strlen(s); i++)
		nr(s,i);

	printf("\nFolosind aceleasi cifre, se pot forma %d numere mai mari decat %s\n\n", r, s);

	free(s);	

	return 0;

}
