/*
BURLACU BOGDAN
GRUPA 1406
TEMA NR. 2
Implementati un program care sa astepte prima apasare a tastei e. Dupa ce s-a
apasat tasta e programul va afisa pe ecran ora curenta actualizata la fiecare
2.2s. Din program se iese la apasarea tastei ESC sau dupa scurgerea a 22s din
momentul apasarii tastei e. Apasarea tastei ESC este considerata abia dupa ce
s-a apasat tasta e.
*/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <time.h>

void interrupt (*oldceas) ();
void interrupt (*oldtast) ();
struct time timp;

int contor = 40;//40 * 50 = 2200 milisecunde = 2.2s
int nr_perioade = 0;//contor pt nr de perioade de cate 2.2s
char c;//pt taste
int e = 0; //flag pt tasta e
int esc = 0; //flag pt tasta esc

void interrupt ceas(void) {

	contor--;
	if (0 == contor) {
		contor = 40;
		nr_perioade++;
	}
	(*oldceas)();//rutina veche

}

void interrupt tast(void) {

	c = inportb(0x60);

	if (c == 0x12){
		e = 1; //s-a apasat tasta e
	}

	if (e == 1){
		if (c == 0x01) //dupa ce s-a apasat e, daca se apasa escape setez flagul esc pe 1
			esc = 1;
	}
	(*oldtast)();//rutina veche
}

P_8253(char canal, char mod, char bcd, int div){

	int port=0x40;
	char octet=0;
	if(canal==1) return 0;
	port+=canal;

	disable();
	octet=octet| (0xc0 & (canal<<6));
	octet=octet| (0x0e & (mod<<1 ) );
	octet=octet| (0x01&bcd);
	octet=octet| 0x30;

	outportb(0x43,octet);
	outportb(port,(char)(div&0xff));/*div, octet low*/
	outportb(port,(char)(div>>8)); /*div, octet high*/
	enable();
}

int main(void) {

	int flag = -1;//flag de urmarire pt nr_perioade
	oldtast = getvect(0x09);//tastatura - salvare adresa rutina veche
	setvect(0x09, tast);//tastatura - rutina noua
	P_8253(0,3,0,28800);/*perioada ceas 50msec*/
	clrscr();

	while (!e);//astept sa se apese tasta e

	//daca a fost apasata tasta e:
	oldceas = getvect(0x08);//ceas - salvare adresa rutina veche
	setvect(0x08, ceas);//ceas - rutina noua
	while (nr_perioade < 10 && !esc)//conditiile din while: ori scurgerea a 22s ori apasarea tastei esc

		if (flag != nr_perioade) {
			gettime(&timp);
			clrscr();
			printf("\nOra curenta: %d:%d:%d.%d\n",timp.ti_hour, timp.ti_min, timp.ti_sec,timp.ti_hund);
			printf("Timp scurs: %.2fs",nr_perioade*2.2);
			flag++;
		}

	//niste mesaje
	if (esc)
		printf("\nS-a apasat ESC, stop.\n");
	else printf("\nAu trecut 22s, stop.\n");

	//refacere vector de intreruperi
	setvect(0x09, oldtast);
	setvect(0x08, oldceas);

	getch();

	return 0;

}
