#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>

char c;
int flag = 0;
int CONTOR = 20;

void interrupt (*oldtast)();

void interrupt newtast(void){
	c = inportb(0x60);
	if (0x01 == c) flag = 1;
	(*oldtast)();
}

void interrupt (*old1c)();

void interrupt my1c(void){
	if (0 != CONTOR) 
		CONTOR--;
}

void asteapta() {
	old1c = getvect(0x1c);
	setvect(0x1c,my1c);
	while(CONTOR);
	setvect(0x1c,old1c);
	CONTOR = 20;
}

int main(void) {

	FILE *file = fopen("DAT.TXT","r");
	char s[20];

	int xmax, ymax;
	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();

	if (file == NULL) {
		printf("Eroare la deschiderea fisierului!\n");
		exit(EXIT_FAILURE);
	}


	if (errorcode !=grOk) {
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		exit(EXIT_FAILURE);
	}
	
	xmax = getmaxx();
	ymax = getmaxy();

	oldtast = getvect(0x09);
	setvect(0x09,newtast);

	while(!flag && (NULL != fgets(s,20,file))){
			//asteapta 1.1s
			asteapta();
			clearviewport();
			line(xmax/2-20,ymax/2-100,xmax/2-20,ymax/2+100);
			line(xmax/2+20,ymax/2-100,xmax/2+20,ymax/2+100);
			line(xmax/2-20,ymax/2-100,xmax/2+20,ymax/2-100);
			//gradatii+marcatii
			line(xmax/2-30,ymax/2-70,xmax/2-20,ymax/2-70);
			outtextxy(xmax/2-50,ymax/2-70,"40");
			line(xmax/2-25,ymax/2-55,xmax/2-20,ymax/2-55);
			line(xmax/2-30,ymax/2-40,xmax/2-20,ymax/2-40);
			outtextxy(xmax/2-50,ymax/2-40,"39");
			line(xmax/2-25,ymax/2-25,xmax/2-20,ymax/2-25);
			line(xmax/2-30,ymax/2-10,xmax/2-20,ymax/2-10);
			outtextxy(xmax/2-50,ymax/2-10,"38");
			line(xmax/2-25,ymax/2+5,xmax/2-20,ymax/2+5);
			line(xmax/2-30,ymax/2+20,xmax/2-20,ymax/2+20);
			outtextxy(xmax/2-50,ymax/2+20,"37");
			line(xmax/2-25,ymax/2+35,xmax/2-20,ymax/2+35);
			line(xmax/2-30,ymax/2+50,xmax/2-20,ymax/2+50);
			outtextxy(xmax/2-50,ymax/2+50,"36");
			line(xmax/2-25,ymax/2+65,xmax/2-20,ymax/2+65);
			line(xmax/2-30,ymax/2+80,xmax/2-20,ymax/2+80);
			outtextxy(xmax/2-50,ymax/2+80,"35");
			//rezervorul+coloana de mercur
			//termometrul citeste temperaturi mai mari de 35 de grade
			arc(xmax/2,ymax/2+134,120,60,40);
			setfillstyle(1,MAGENTA);
			fillellipse(xmax/2,ymax/2+134,40,40);
			bar(xmax/2-19,ymax/2+80-(atof(s)-35)*30,xmax/2+19,ymax/2+100);
			outtextxy(10,20,s);
			//led de avertizare
			if (atof(s)<36) setfillstyle(1,BLUE);
			if (atof(s)>=36 && atof(s)<37) setfillstyle(1,GREEN);
			if (atof(s)>=37 && atof(s)<38) setfillstyle(1,YELLOW);
			if (atof(s)>=38) setfillstyle(1,RED);
			fillellipse(xmax-50,50,20,20);
	}
	
	setvect(0x09, oldtast);
	closegraph();
	return 0;
}
