/*
Sa se deseneze un bradut si sa se realizeze un model de instalatie de pom pentru acesta. De exemplu, la apasarea tastei 'r' se vor aprinde beculetele rosii din instalatie, la apasara tastei 'v' se vor aprinde cele verzi, etc., dupa cum isi imagineaza fiecare. Toate afisarile for fi active timp de 1.1 secunde, interval de timp in care apasarea altor taste este neglijata.Programul trebuie realizat in C prin rescrierea rutinei de tratare a intreruperii de tastatura si ceas.
*/

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <conio.h>

int ESC = 0;//escape = iesire din program
int r = 0;//rosu
int a = 0;//albastru
int g = 0;//galben
char c;
int CONTOR = 20;
int xmax, ymax, midx, midy;

void interrupt (*oldtast)();

void interrupt newtast(void) {
	c = inportb(0x60);
	if (0x01 == c) ESC = 1;
	if (0x13 == c) r = 1;
	if (0x22 == c) g = 1;
	if (0x1e == c) a = 1;
	(*oldtast)();
}

void interrupt (*old1c)();

void interrupt my1c(void) {
	if (CONTOR > 0) CONTOR--;
}

void asteapta() {
	setvect(0x1c,my1c);//my1c
	while(CONTOR);
	setvect(0x1c,old1c);//old1c
	setvect(0x09,newtast);
	CONTOR = 20;
	r = 0;
	g = 0;
	a = 0;
}

void draw_tree() {

	//bradul
	setcolor(GREEN);
	line(midx,midy-200,midx,midy+150);
	line(midx-150,midy+150,midx+150,midy+150);
	line(midx-150,midy+150,midx,midy-200);
	line(midx+150,midy+150,midx,midy-200);
	line(midx,midy+70,midx+150,midy+150);
	line(midx,midy+70,midx-150,midy+150);
	line(midx,midy-70,midx-75,midy-25);
	line(midx,midy-70,midx+75,midy-25);
	line(midx,midy,midx-112,midy+62);
	line(midx,midy,midx+112,midy+62);
	line(midx,midy-130,midx-43,midy-100);
	line(midx,midy-130,midx+43,midy-100);
	setcolor(MAGENTA);
	rectangle(midx-20,midy+151,midx+20,midy+200);

}

void draw_lights() {

	//instalatia
	setcolor(WHITE);
	setfillstyle(1,BLACK);
	fillellipse(midx-150,midy+150,7,7);
	fillellipse(midx+150,midy+150,7,7);
	fillellipse(midx,midy+150,7,7);
	fillellipse(midx,midy-200,7,7);
	fillellipse(midx,midy,7,7);
	fillellipse(midx-75,midy-25,5,5);
	fillellipse(midx+75,midy-25,5,5);
	fillellipse(midx,midy-130,5,5);
	fillellipse(midx,midy+70,5,5);
	fillellipse(midx,midy-70,7,7);
	fillellipse(midx-112,midy+62,5,5);
	fillellipse(midx+112,midy+62,5,5);
	fillellipse(midx-43,midy-100,5,5);
	fillellipse(midx+43,midy-100,5,5);

}

int main(void) {

	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();

	if (errorcode != grOk) {
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		exit(EXIT_FAILURE);
	}

	old1c = getvect(0x1c);
	oldtast = getvect(0x09);
	setvect(0x09,newtast);

	xmax = getmaxx();
	ymax = getmaxy();

	midx = xmax/2;
	midy = ymax/2;
	
	draw_tree();
	draw_lights();

	while(!ESC) {
		if (r == 1) {
			setfillstyle(1,RED);
			fillellipse(midx-150,midy+150,7,7);
			fillellipse(midx+150,midy+150,7,7);
			fillellipse(midx,midy,7,7);
			fillellipse(midx,midy-200,7,7);
			asteapta();
			draw_lights();
		}
		
		if (g == 1) {
			setfillstyle(1,YELLOW);
			fillellipse(midx,midy+150,7,7);
			fillellipse(midx-75,midy-25,5,5);
			fillellipse(midx+75,midy-25,5,5);
			fillellipse(midx,midy-130,5,5);
			fillellipse(midx,midy+70,5,5);
			asteapta();
			draw_lights();
		}

		if (a == 1) {
			setfillstyle(1,BLUE);
			fillellipse(midx-112,midy+62,5,5);
			fillellipse(midx+112,midy+62,5,5);
			fillellipse(midx,midy-70,7,7);
			fillellipse(midx-43,midy-100,5,5);
			fillellipse(midx+43,midy-100,5,5);
			asteapta();
			draw_lights();
		}
	}
	closegraph();

	setvect(0x09,oldtast);
	return 0;

}
