#include <dos.h>
#include <bios.h>
#include <stdio.h>

int flag = 0;//flag pt tasta a
int contor;
char c;
int trigger = 55;

void interrupt (*oldceas)();
void interrupt (*oldtast)();

void interrupt newceas(void) {
  if (0 != contor) contor--;
	trigger--;
	if (0 == trigger){
		trigger = 55;
		(*oldceas)();
	} else outportb(0x20,0x20);
}

void interrupt newtast(void) {
	c = inportb(0x60);
	if (c == 0x1e) {
		flag = 1;
		outportb(0x61,inportb(0x61)&0xfc);/*invalidare sunet; gate=bo=0*/
	}
	(*oldtast)();
}

P_8253(char canal, char mod, char bcd, int div){

	int port=0x40;
	char octet=0;
	if(canal==1) return 0;
	port+=canal;

	disable();
	octet=octet| (0xc0 & (canal<<6));
	octet=octet| (0x0e & (mod<<1 ) );
	octet=octet| (0x01&bcd);
	octet=octet| 0x30;

	outportb(0x43,octet);
	outportb(port,(char)(div&0xff));/*div, octet low*/
	outportb(port,(char)(div>>8)); /*div, octet high*/
	enable();
}

void wait(int msec) {
	
	contor = msec;

	P_8253(0,3,0,1192);/*perioada ceas 1msec*/

	oldceas = getvect(0x08);
	setvect(0x08,newceas);

	while(contor && !flag);

	P_8253(0,3,0,0);/*perioada ceas 1msec*/

	setvect(0x08,oldceas);
}	


int main(void) {

  int c_div;

	outportb(0x43,0xb6);
	outportb(0x61,inportb(0x61)|0x03);/*validare sunet; gate=bo=1*/

	oldtast = getvect(0x09);
	setvect(0x09, newtast);

	while (!flag) {

		c_div=1190000L/1500;
		outportb(0x42,c_div%256);/*c_div,octet low*/
		outportb(0x42,c_div/256);/*c_div,octet high*/
		if (!flag) wait(1100);
	
		c_div=1190000L/2000;
		outportb(0x42,c_div%256);/*c_div,octet low*/
		outportb(0x42,c_div/256);/*c_div,octet high*/
		if (!flag) wait(2200);

		c_div=1190000L/2500;
		outportb(0x42,c_div%256);/*c_div,octet low*/
		outportb(0x42,c_div/256);/*c_div,octet high*/
		if (!flag) wait(3300);
	}

	setvect(0x09, oldtast);
	return 0;
}
