#include <dos.h>
#include <bios.h>
#include <stdio.h>
#include <conio.h>

int flag = 0;//flag pt tasta a
int nr_a = 0;//nr de apasari ale tastei a
char c;//pt testarea tastei apasate
int contor = 100;//100 msec
int trigger = 55;
void interrupt (*oldceas)();
void interrupt (*oldtast)();

void interrupt newceas(void) {
	if (0 != contor) contor--;
	trigger--;
	if (0 == trigger){
		trigger = 55;
		(*oldceas)();
	} else outportb(0x20,0x20);
}

void interrupt newtast(void) {
	c = inportb(0x60);
	if (c == 0x1e) {
		//plasand acest if inainte de a schimba flag-ul, ignor prima apasarea a tastei a, si contorizez doar apasarile aparute in intervalul de 100ms
		if (flag == 1) nr_a++;
		flag = 1;
	}
	(*oldtast)();
}

P_8253(char canal, char mod, char bcd, int div){

	int port=0x40;
	char octet=0;
	if(canal==1) return 0;
	port+=canal;

	disable();
	octet=octet| (0xc0 & (canal<<6));
	octet=octet| (0x0e & (mod<<1 ) );
	octet=octet| (0x01&bcd);
	octet=octet| 0x30;

	outportb(0x43,octet);
	outportb(port,(char)(div&0xff));/*div, octet low*/
	outportb(port,(char)(div>>8)); /*div, octet high*/
	enable();
}

int main(void) {

	oldtast = getvect(0x09);
	oldceas = getvect(0x08);

	setvect(0x09,newtast);
	printf("Apasati tasta a\n");
	while (!flag);

	P_8253(0,3,0,1192);/*perioada ceas 1msec*/
	setvect(0x08,newceas);

	printf("BRAVO, mesaj 1\n");

	while(contor);

	setvect(0x09, oldtast);//refac rutina veche pt tastatura, ca sa nu mai tin cont de apasarile tastei a dupa ce au trecut cele 100ms

	contor = (nr_a) * 100;

	while(contor);

	clrscr();

	//printf("\nnr_a = %d (nu se tine cont de prima apasare)\n",nr_a);
	//printf("\nnr_a = %d\n",nr_a/2); //incorect, din motive inca neelucidate//
	printf("\nAm scapat dupa %d msec!!\n",nr_a*100+100);
	//printf("\nAm scapat dupa %d msec!!\n",(nr_a/2)*100+100);//incorect//

	P_8253(0,3,0,0);/*perioada ceas 55msec*/
	setvect(0x08, oldceas);
	sleep(1);
	return 0;

}
